#!/usr/bin/env python3

import binascii
from btchip import btchip
from btchip.btchipComm import getDongle
from btchip import bitcoinTransaction

dongle = getDongle(True)
app = btchip.btchip(dongle)

segwit_inputs = [{'sequence': 'fdffffff',
  'value': b'\xcd\xae\xbf\x10\x0c-\xfb\x8fF\xf7k=a\x0f~\x07\xa7\x9a`\xbc'
           b'\xb2n\xa9\xcc\xe6\xe3\xab\x8dQ\xb3\xef\xf4\x00\x00\x00\x00'
           b'\x00\xe1\xf5\x05\x00\x00\x00\x00',
  'witness': True}]

tx_bytes = b'\x02\x00\x00\x00\x01\xcd\xae\xbf\x10\x0c-\xfb\x8fF\xf7k=a\x0f~\x07\xa7\x9a`\xbc\xb2n\xa9\xcc\xe6\xe3\xab\x8dQ\xb3\xef\xf4\x00\x00\x00\x00\x00\xfd\xff\xff\xff\x01\xb2\xd9\xf5\x05\x00\x00\x00\x00"\x00 A{\xcf\xb9^\x94\xee\xc3i\x03?\x10\xb5\xd0i\xc8\xfd\xa59\xfd\xafO0j\xdc!D\x8d\xcf)fj\x00\x00\x00\x00'

script_code = b'cR!\x03%\xa4<$\xb8\x8au\xe5\t\xc8\xe0\xaec\xd1t\xdf\xb9\xb7\xdd\xca\xbe\xea\xce)\x04\xed\xa4\xdc\xfcI\x00\xae!\x03{\xe2\x08G\x1d\x8f\xac\xf1\xa6\xda=*\xe6\x0b\x88K{\xd4\x8f\xbd\xe05\xa6RR\xbf\\\xf6\xcb!c\xa8!\x03\x90\xab\x06-\xdbB#\x0b\xfaM\x80\xb4\x9d\x06l\x02k\x0f\x05\xe0\xb6\xda&G\r\x94\xd4\xb8\x06"\x1e\x8fS\xaeg\x02\xf4\x01\xb2uR!\x03%\xa4<$\xb8\x8au\xe5\t\xc8\xe0\xaec\xd1t\xdf\xb9\xb7\xdd\xca\xbe\xea\xce)\x04\xed\xa4\xdc\xfcI\x00\xae!\x02\xb0\r\xf1\xd5\xd8\xc1\xb8\x06\x1d\xad\x8fL \xe2\xdab\x83\xf9Hf\xe1\x8b\xa8\xd2\x80\xdd\xcf\xe0|Y-L!\x02\x109\xafE\xef\x98\xa7\xbe\xd5\xba\x12n\xe3\xc9\xb3\xc4\xcc\xc83\xf7\x12b7\x16\x8e\xa0\xfa\xb4\xa9d\xc0\x84S\xaeh'

path="2147483692/2147483648/0/0"

tx = bitcoinTransaction.bitcoinTransaction(tx_bytes)
authHash = tx.serialize()

print("app.startUntrustedTransaction()")
app.startUntrustedTransaction(True, 0, segwit_inputs, bytearray(), 2)

print(binascii.hexlify(tx_bytes))

print("app.finalizeInput()")
app.finalizeInput(b"DUMMY", -1, -1, '', tx_bytes)

print(binascii.hexlify(script_code))

print("app.startUntrustedTransaction()")
app.startUntrustedTransaction(False, 0, segwit_inputs, script_code, 2)

print("app.untrustedHashSign()")
app.untrustedHashSign(path, "", 0, 0x01)

print("done")

